﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;

namespace WpfApplication20
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow1 : Window
    {
        private bool isDragging;
        private Point previousePoint;
        private const int w = 10;
        private const int h = 10;

        public MainWindow1()
        {
            InitializeComponent();

            for (int i = 0; i < 1000; i++)
            {
                ImagePanel.Children.Add(new Image() { Width = 1000, Height = 1000 });
            }
        }

        private void Panel_MouseMove(object sender, MouseEventArgs e)
        {
            previousePoint = e.GetPosition(this);
            if (isDragging)
            {
                Update();
            }
        }

        private void Panel_MouseUp(object sender, MouseButtonEventArgs e)
        {
            Update();
            isDragging = false;
        }

        private void Panel_MouseDown(object sender, MouseButtonEventArgs e)
        {
            isDragging = true;
            Update();
        }

        private void Update()
        {
            DrawingVisual drawingVisual = new DrawingVisual();
            DrawingContext context = drawingVisual.RenderOpen();
            context.DrawEllipse(new SolidColorBrush(Colors.Red), new Pen(new SolidColorBrush(Colors.Black), 2), new Point(previousePoint.X, previousePoint.Y), w * .5, h * .5);
            context.Close();

            RenderTargetBitmap nativeImage = new RenderTargetBitmap((int)ActualWidth, (int)ActualHeight, 96, 96, PixelFormats.Pbgra32);
            nativeImage.Render(drawingVisual);
            Image1.Source = nativeImage;
            GC.Collect();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Image1.Width = ActualWidth;
            Image1.Height = ActualHeight;
        }
    }
}